> For the complete documentation index, see [llms.txt](https://docs.citrea.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.citrea.xyz/developer-documentation/ecosystem-tooling/oracles-vrf.md).

# Oracles & VRF

## Available on Mainnet and Testnet

### Redstone

[Redstone](https://redstone.finance) is a modular oracle network that provides secure price feeds for blockchain protocols.

The following price feeds are provided by Redstone on Citrea Mainnet: `BTC/USD`, `USDC/USD`, `USDT/USD`, `aUSD/USD`.

You can find the contract addresses & feeds on the Redstone documentation for [mainnet](https://app.redstone.finance/app/feeds/?page=1\&sortBy=popularity\&sortDesc=false\&perPage=32\&networks=4114) and for [testnet](https://app.redstone.finance/app/feeds/?page=1\&sortBy=popularity\&sortDesc=false\&perPage=32\&networks=5115).

***

## Available on Testnet

### Stork

[Stork](https://stork.network) provides real-time price feeds using a pull-oracle model. It allows developers to fetch the latest price data on demand, ensuring they always have access to the most current information.

You can check the Stork documentation [here](https://docs.stork.network/) to kickstart your development. Stork contracts deployed on Citrea Testnet are at the following address: [0x266795f5A45AEc26aBF7E1c923dC15Cbb1A4Ed96](https://explorer.testnet.citrea.xyz/address/0x266795f5A45AEc26aBF7E1c923dC15Cbb1A4Ed96?tab=contract)

***

### Supra dVRF

Supra dVRF delivers randomness that’s:

* Low-latency
* Tamper-proof (via threshold signatures + secret sharing)
* Unbiased + unpredictable (based on blockhash, nonce & user input)
* Verifiable on-chain with cryptographic proof

You can find the documentation for Supra dVRF [here](https://docs.supra.com/dvrf/v2-guide) and the contracts deployed on Citrea Testnet at the following addresses:

* **Router**: [0xDF666c76E859D6541FF17E1C6c215e46BfA563B2](https://explorer.testnet.citrea.xyz/address/0xDF666c76E859D6541FF17E1C6c215e46BfA563B2?tab=contract)
* **Deposit**: [0xcF99ab8c2AABC04349139484BAFC26f480Ef4cE4](https://explorer.testnet.citrea.xyz/address/0xcF99ab8c2AABC04349139484BAFC26f480Ef4cE4?tab=contract)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.citrea.xyz/developer-documentation/ecosystem-tooling/oracles-vrf.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
